--- configure.ac	2023-05-19 22:19:44.000000000 -0300
+++ configure.ac.fixed	2023-12-27 16:38:43.520064640 -0400
@@ -560,14 +560,23 @@
 GOFFICE_CHECK_FUNC(acosh)
 GOFFICE_CHECK_FUNC(atanh)
 
+AC_TYPE_LONG_DOUBLE
+dnl go-ryu needs __uint128_t for long double support.
+AC_CHECK_TYPES([__uint128_t], [], [], [[#include <inttypes.h>
+#include <stdint.h>]])
+if test $ac_cv_type_long_double.$ac_cv_type___uint128_t = yes.yes; then
+  with_long_double_default=yes
+else
+  with_long_double_default=no
+fi
+
 float_msg=no
 AC_ARG_WITH(long-double,
         [  --without-long-double   disable support for long double],
-        , [ with_long_double=yes])
+        , [ with_long_double=$with_long_double_default])
 
 if test "x$with_long_double" = "xyes"; then
-  AC_TYPE_LONG_DOUBLE
-  if test $ac_cv_type_long_double = yes; then
+  if test $with_long_double_default = yes; then
     have_mandatory_funcs=yes
     need_sunmath=0
     ss_ccprog=`echo $CC | sed -e 's/ .*//'`
